#!C:/usr/perl/bin/perl.exe
# XMail MailBox Monitor
# Written By: Shawn Anderson (sanderson@eye-catcher.com)
# Created On: 2001-11-01

#--------------------------------------------------------------------------------
# Version History
#--------------------------------------------------------------------------------
# Date			Version	Name				Description
#--------------------------------------------------------------------------------
# 2001-11-01	1.0		Shawn Anderson		Initial Version

#--------------------------------------------------------------------------------
# Usage Information
#--------------------------------------------------------------------------------
# This script will iterate through all domains directories and user directories
# and determine if a user is over there mail quota limit as defined in the user.tab
# file. If a user is over the limit it will send them a message by putting a mail
# file in the spool/local directory. This file is generated from one of several
# possible templates. The templte chosen if be searching for the first one found.
# The search order is as follows.

# Possible Templtes:
#	<domain>.<user>.tpl
#	<domain>.tpl
#	<mailquota>.tpl
#	An internal default

# One of the best ways to use this is to schedule it to run daily or weekly via crond or
# at.

#--------------------------------------------------------------------------------
# Required Libraries
#--------------------------------------------------------------------------------
eval "use File::Stat";		# Windowsłstat
eval "use File::stat";

###
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
require "./jcode.pl";
require "./config.cgi";
($mailroot,$xmaildir) = ($cfg{mailroot}, $cfg{xmaildir});
$mailroot =~ s/\\/\//g;
$xmaildir =~ s/\\/\//g;
$criteria = $ARGV[0];
###

#--------------------------------------------------------------------------------
# User Configurable Settings
#--------------------------------------------------------------------------------
$XMail_MailRoot = "$mailroot";
$TemplateDir	= "$xmaildir/MailTemplates";
$TempDir	= "$xmaildir/temp";
if (! -e "$TemplateDir"){mkdir("$TemplateDir",0755);}
if (! -e "$TempDir"){mkdir("$TempDir",0755);}

#$SendReportToAdmin = 0;	# Diabled
$SendReportToAdmin = 1;		# Enabled

$SendUserEmails = 0;		# Disabled
#$SendUserEmails = 1;		# Enabled

$AdminEmailAddress		= "$postmaster";

# These are variables that can be used in the templates
$QuotaMailFrom			= "$postmaster";
$QuotaMailFromName		= "localhost";
$QuotaMailSupportAddress	= "$postmaster";
$QuotaMailSubject 		= "You are currently over your mail quota limit!";

# Choose one of the following to determine the level of display detail
#$Verbose		= 0; # Print Out Nothing But Headers
$Verbose		= 1; # Print Out Errors
#$Verbose		= 2; # Print Out Error and Basic Info
#$Verbose		= 3; # Print Out Everything

# This is a default template for the quota management.
# It is ONLY used if non of the template files are found in the
# template directory.
# Please modify this ONLY if it is really necessary
$TemplateDefault =  "mail from:<%QuotaMailFrom%>\n";
$TemplateDefault .= "rcpt to:<%user%>\n";
$TemplateDefault .= "\r\n";
$TemplateDefault .= "subject: %QuotaMailSubject%\n\n";
$TemplateDefault .= "This is a curtesey email that is being send out to you to inform you\n";
$TemplateDefault .= "that you are over your mailbox quota.  This means that you currently\n";
$TemplateDefault .= "have to much email being stored on our server.  As a result of this\n";
$TemplateDefault .= "your account has been temporarly suspended.  This means that until\n";
$TemplateDefault .= "you remove some of the mail from our sever, you will not be able to\n";
$TemplateDefault .= "receive any new mail.  If you have any questions please contact us\n";
$TemplateDefault .= "at %QuotaMailSupportAddress%\n";
$TemplateDefault .= "\n";
$TemplateDefault .= "Thank you,\n";
$TemplateDefault .= "\t%QutoaMailMessageFromName%\n";

#--------------------------------------------------------------------------------
$Version = "1.0";

my %AdminReport;
my $xmaildir_domain = $XMail_MailRoot . "/domains";

my $XMQuotaMonitorFooter = "XMQuotaMonitor $Version (c) 2001 xmail.eye-catcher.com\r\n";

# Do Not Change This!!!!
my $mailCount = 0;
my $localhostname = `hostname`;

chomp $localhostname;

#--------------------------------------------------------------------------------
# Display Startup Information
#--------------------------------------------------------------------------------

print "Content-Type: text/html; charset=EUC-JP\nCacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
print <<EOD;
<TITLE>
XMail Quota Monitor
</TITLE>
<html>
<body bgcolor='#ffffff'>
<p><b><a href="javascript:history.go( -1)">&lt;&lt;Back</a></b></p>
XMQuotaMonitor<br>
Written By: Shawn Anderson (sanderson\@eye-catcher.com) (c) 2001<br>
Version: $Version<br>
EOD
#Output (0, "XMQuotaMonitor");
#Output (0, "Written By: Shawn Anderson (sanderson\@eye-catcher.com) (c) 2001");
#Output (0, "Version: $Version\r\n");

#--------------------------------------------------------------------------------
# Start Processing
#--------------------------------------------------------------------------------

Output (2, "Reading Domain List");

@domains = GetDirList($xmaildir_domain, 0);

foreach $domain (@domains){
	ProcessDomain($xmaildir_domain, $domain);
}

if ($SendReportToAdmin){
	ReportToAdmin();
}

print <<EOD;
</body>
</html>
EOD
1;

#--------------------------------------------------------------------------------
sub ProcessDomain
{
	local($root_dir, $domain) = @_;
	local(@users);

	Output (2, "Reading User List For $domain");

	@users = GetDirList("$root_dir/$domain", 0);

	foreach $user (@users) {
		if (-d "$root_dir/$domain/$user") {
			ProcessUser($root_dir, $domain, $user);
		}
	}
}

#--------------------------------------------------------------------------------
sub ProcessUser
{
	local($root_dir, $domain, $user) = @_;
	local(%userInfo, $mailDirSize);

	$mailDirSize 		= 0;
	$userInfo{"MaxMBSize"} 	= 0;

	%userInfo = ReadXMailUserSettings("$root_dir/$domain/$user");

	if (-e "$root_dir/$domain/$user/maildir") {
		$mailDirSize = GetDirSize("$root_dir/$domain/$user/maildir", "true");
	} elsif (-e "$root_dir/$domain/$user/mailbox") {
		$mailDirSize = GetDirSize("$root_dir/$domain/$user/mailbox", "false");
	} else {
		return();
	}

	Output (2, "Processing: $user");
	Output (2, "\tMax MailBox Size: " . $userInfo{"MaxMBSize"});
	Output (2, "\tCurrent MailBox Size: $mailDirSize");

	if ($userInfo{"MaxMBSize"} < $mailDirSize) {
		if ($SendUserEmails) {
			SendOverQuotaMail($domain, $user, $mailDirSize, \%userInfo);
		}
	}

	$AdminReport{$domain}{$user}{"CurrentMBSize"} 	= $mailDirSize;
	$AdminReport{$domain}{$user}{"MaxMBSize"} 	= $userInfo{"MaxMBSize"};
}

#--------------------------------------------------------------------------------
sub ReportToAdmin
{
	local($text);
	local(%domainInfo, $domain, %userInfo, %user);
	local($now, $maxSize, $currentSize, $percent);
	local($totalSize, $domainCount, $userCount);

	print "<pre>";
	print "Creating Admin Report";

	$now 		= localtime;
	$totalSize	= 0;
	$domainCount	= 0;
	$userCount 	= 0;

	print "subject: XMQutoaMonitor Report For $now\n\n";
	print "Here is the report that you requested.\n\n";
	print "-------------------------------------------------------------------\n";
	printf("%-35s %-10s %-10s %-10s\n", "E-mail address", "Max [kB]", "Use [kB]", "[%]");
	print "-------------------------------------------------------------------\n";

	foreach $domain (sort keys %AdminReport) {
		Output(2, "Reporting Domain: $domain");

		*domainInfo = $AdminReport{$domain};

		foreach $user (sort keys %domainInfo) {
			Output(2, "Reporting User: $user\@$domain");

			*userInfo = $domainInfo{$user};

			$maxSize 	= 0;
			$currentSize 	= 0;
			$precent	= 0;

			$maxSize 	= $userInfo{"MaxMBSize"} * 1024.0;
			$currentSize 	= $userInfo{"CurrentMBSize"} * 1.0;

			if ($currentSize > 0) {
				$percent = ($currentSize * 100.0) / $maxSize ;
			} else {
				$percent = 0.0;
			}
			
			$totalSize += $currentSize;
			$userCount++;
			
			if ($percent <= $criteria && $criteria ne ''){next;}
			
			printf("%-30s, %10d, %10d, %6.2lf\n",
				$user . '@' . $domain, $maxSize / 1024.0,
				$currentSize / 1024.0, $percent);
			# print ("$text\n");
		}
		$domainCount++;
	}

	print  "--------------------------------------------------------------------\n";
	print  " \n";
	print  "--------------------------------------------------------------------\n";
	print  "Total Domains: $domainCount\n";
	print  "Total Users: $userCount\n";
	printf("Total Size:%8.2f[MB]\n", $totalSize / (1024*1024));
	print "--------------------------------------------------------------------\n";
	print "$XMQuotaMonitorFooter\n";

	print "</pre>";

	#CreateMailFileInLocalSpool($AdminEmailAddress, "adminreport", $text);
}

#--------------------------------------------------------------------------------
sub ReadXMailUserSettings
{
	local($userDir) = @_;
	local(%userInfo);
	local(@fileInfo);

	@fileInfo = ReadFile($userDir . "/user.tab");

	foreach $line (@fileInfo)
	{
		($userVar, $userValue) = split(/\t/, $line);

		$userVar =~ s/\"//g;
		$userValue =~ s/\"//g;

		$userInfo{$userVar} = $userValue;
	}

	return (%userInfo);
}

#--------------------------------------------------------------------------------
sub SendOverQuotaMail
{
	local($domain, $user, $currentMailBoxSize, %userInfo) = @_;
	local($fileText, @fileInfo, $output);
	local($tplFile);
	local($newLine);

	Output (2, "$user in $domain is over their mailbox quota");

	if (-e "$TemplateDir/$domain.$user.tpl") {
		@fileInfo = ReadFile("$TemplateDir/$domain.$user.tpl");
	} elsif (-e "$TemplateDir/$domain.tpl")	{
		@fileInfo = ReadFile("$TemplateDir/$domain.tpl");
	} elsif (-e "$TemplateDir/mailquota.tpl") {
		@fileInfo = ReadFile("$TemplateDir/mailquota.tpl");
	} else {
		$fileText = $TemplateDefault;
		@fileInfo = split(/\r\n/, $fileText);
	}

	$fileText = join('!~!~!', @fileInfo);

	$fileText =~ s/!~!~!/\r\n/g;

	$fileText =~ s/%user%/$user/g;
	$fileText =~ s/%domain%/$domain/g;
	$fileText =~ s/%CurrentMailBoxSize%/$currentMailBoxSize/g;
	$fileText =~ s/%RealName%/$userInfo{"RealName"}/g;
	$fileText =~ s/%MaxMBSize%/$userInfo{"MaxMBSize"}/g;
	$fileText =~ s/%QuotaMailFrom%/$QuotaMailFrom/g;
	$fileText =~ s/%QuotaMailFromName%/$QuotaMailFromName/g;
	$fileText =~ s/%QuotaMailSupportAddress%/$QuotaMailSupportAddress/g;
	$fileText =~ s/%QuotaMailSubject%/$QuotaMailSubject/g;

	$fileText .= "\r\n" . $XMQuotaMonitorFooter;

	Output (4, "Text:\r\n$fileText t");

	CreateMailFileInLocalSpool($domain, $user, $fileText);
}

#--------------------------------------------------------------------------------
sub CreateMailFileInLocalSpool
{
	local($domain, $user, $text) = @_;
	local($filename, $tempFileName, *FILE);
	local($count);

	$count = sprintf("%03d", $mailCount++);

	$fileName = "$XMail_MailRoot/spool/local/" . time() . "-$count.$$.$localhostname";
	#$fileName = "$XMail_MailRoot/spool/local/$domain.$user.tmp$$";

	$tempFileName = "$TempDir/" . time() . "-$count.$$.$localhostname";

	Output(3, "Creating : $fileName");

	open(FILE, ">$tempFileName") || Output (1, "Could not create $tempFileName. Error: $!");
	print FILE $text;
	close(FILE);

	Output(3, "Moving  $tempFileName to $fileName");

	move($tempFileName, $fileName) || Output (1, "Could not move temp file to spool directory. Error:

$!");
}

#--------------------------------------------------------------------------------
sub ReadFile
{
	local($file) = @_;
	local(@fileInfo);
	local(*FILE);
	local($line);

	open(FILE, $file) || Output (1, "Could not open file: $file. Error: $!");

	while (<FILE>) {
		$line .= $_;
	}

	close(FILE);

	@fileInfo = split(/\n/, $line);

	return (@fileInfo);
}

#--------------------------------------------------------------------------------
sub GetDirSize
{
	local($dir, $recursive) = @_;
	local($totalsize);
	local($st);
	local($size);

	Output (4, "GetDirSize: $dir [$recursive]");

	@mailboxfiles = GetDirList($dir, $recursive);

	$totalsize = 0;
	foreach $file (@mailboxfiles) {
		$st = stat($dir . "/" . $file) || Output(1, "Could Not Do A Stat on $file: $!");

#		$size = $st->size;
#		$totalsize += $size;
		$totalsize += -s "$dir/$file";
	}

	return $totalsize;
}

#--------------------------------------------------------------------------------
sub GetDirList
{
	local($dirName, $recursive) = @_;
	local(@dirs);

	Output (4, "GetDirList: $dirName [$recursive]");

	if (-d "$dirName") {
		opendir(DIR, $dirName) || Output (1, "Could not open $dirName: $!");

		@dirs = grep { !/^\./ } readdir(DIR);

		closedir DIR;

		if ($recursive) {
			foreach $dir (@dirs) {
				$subDir = "$dirName/$dir";
				if (-d $subDir) {
					push (@dirs, GetDirList($subDir, $recursive));
				}
			}
		}
		return @dirs;
	} else {
		return "";
	}
}

#--------------------------------------------------------------------------------
sub Output
{
	local($lvl, $msg) = @_;

	if ($Verbose >= $lvl){
		printf ($msg . "\r\n");
	}
}
